import { FC, InputHTMLAttributes } from 'react';
export declare type TaskStatus = 'pending' | 'fail';
export interface FileItem {
    url: string;
}
export declare type ImageUploaderProps = {
    defaultValue?: FileItem[];
    value?: FileItem[];
    onChange?: (fileList: FileItem[]) => void;
    accept?: string;
    multiple?: boolean;
    maxCount?: number;
    onCountExceed?: (exceed: number) => void;
    disableUpload?: boolean;
    showUpload?: boolean;
    deletable?: boolean;
    capture?: InputHTMLAttributes<unknown>['capture'];
    onPreview?: (index: number) => void;
    beforeUpload?: (file: File[]) => Promise<File[]> | File[];
    upload: (file: File) => Promise<FileItem>;
    onDelete?: (file: FileItem) => boolean | Promise<boolean> | void;
};
export declare const ImageUploader: FC<ImageUploaderProps>;
