import { FC } from 'react';
import { NativeProps } from '../../utils/native-props';
export declare type WaterMarkProps = {
    /**
     * 水印之间的水平间距
     */
    gapX?: number;
    /**
     * 水印之间的垂直间距
     */
    gapY?: number;
    /**
     * 追加的水印元素的z-index
     */
    zIndex?: number;
    /**
     * 水印的宽度
     */
    width?: number;
    /**
     * 水印的高度
     */
    height?: number;
    /**
     * 水印绘制时，旋转的角度，单位 °
     */
    rotate?: number;
    /**
     * 高清印图片源, 为了高清屏幕显示，建议使用 2倍或3倍图，优先使用图片渲染水印。
     */
    image?: string;
    /**
     * 图片宽度
     */
    imageWidth?: number;
    /**
     * 图片高度
     */
    imageHeight?: number;
    /**
     * 水印文字内容
     */
    content?: string;
    /**
     * 文字颜色
     */
    fontColor?: string;
    /**
     * 文字样式
     */
    fontStyle?: 'none' | 'normal' | 'italic' | 'oblique';
    /**
     * 文字族
     */
    fontFamily?: string;
    /**
     * 文字粗细
     */
    fontWeight?: 'normal' | 'light' | 'weight' | number;
    /**
     * 文字大小
     */
    fontSize?: number | string;
} & NativeProps;
export declare const WaterMark: FC<WaterMarkProps>;
