import { useCallback, useRef } from 'react';
import { useUpdate } from 'ahooks';
export function useNewControllableValue(options) {
  var value = options.value,
      defaultValue = options.defaultValue,
      onChange = options.onChange;
  var update = useUpdate();
  var stateRef = useRef(value !== undefined ? value : defaultValue);

  if (value !== undefined) {
    stateRef.current = value;
  }

  var setState = useCallback(function (v) {
    if (value === undefined) {
      stateRef.current = v;
      update();
    }

    onChange === null || onChange === void 0 ? void 0 : onChange(v);
  }, [value, update, onChange]);
  return [stateRef.current, setState];
}